/*
 * Dinge die definiert werden mssen:
 *  
 *  baseValues: Namen
 *  
 *  coldef: Spalten fr die Gridansicht und Editmodus { 
 *  	renderfkt : null fr standard-renderer, ansonsten eigene FKT : Optional, nur Grid 
 *  	name : ID der Spalte,    
 *  	title : berschrift, 
 *  	description: Beschreibung des Wertes  : Tooltip
 *  	type : folgende Typen:
 *  		* string/null: String
 *          * integer: Zahl
 *          * trigger: 
 *          * action: 
 *          * message: Nachricht (Email)
 *  }
 *  
 * */

//https://10.0.35.100/json/property/query?query=/apartment/zones/*(ZoneID,isPresent,name)/groups/*(name,group)/scenes/*(scene,name)

var baseValues = {
	appId : 'presence-simulator',
	editorTitle : {'holidays':'Urlaub','actions':'Aktion'},
	newEntry : {'holidays':'Urlaub hinzuf&uuml;gen','actions':'Aktion hinzuf&uuml;gen'},
	editEntry : {'holidays':'Urlaub bearbeiten','actions':'Aktion bearbeiten'},
	disableEntry : {'holidays':'','actions':'Aktion abschalten'},
	enableEntry : {'holidays':'','actions':'Aktion anschalten'},
	deleteEntry : {'holidays':'Urlaub l&ouml;schen','actions':'Aktion l&ouml;schen'},
	helpText : "help_de.html"
};

function initValues() {
	login();
	initCaches();
}

function checkMinimalVersion()
{
	var sVersion=getPropertyString('/system/version/version');
	var oArray=sVersion.split(".");
	var iVersion_main=parseInt(oArray[0],10);
	var iVersion_min=parseInt(oArray[1],10);
	
	var minimalVersion=true;
	if (iVersion_main<1)
		minimalVersion=false;
	if (iVersion_main==1)
	{
		if (iVersion_min<2)
			minimalVersion=false;
	}
	if (minimalVersion==false)
	{	
		return 'Diese App ben&ouml;tigt minimal die dSS-Version <b>1.2.0</b><br>' +
		       'Bitte f&uuml;hren Sie das kostenlose Systemupdate durch.<br>'+
		       'Dies kann im Konfigurator in der erweiterten Ansicht unter <b>System</b> -&gt; <b>System Update</b> gestartet werden.';
	}
	return true;
	
}

function loadValueFunction(id) {
	// /scripts/presence-simulator/values/holiday/*(name,id,von,bis)
	// /scripts/presence-simulator/values/actions/*(name,id,time,maxdiv,disabled)/*(0,1,2,3,4,5,6,7)/*(zone,group,scene,delay)
	// /scripts/presence-simulator/values/timed-event/*(id,timed-event-ref,disabled)
	// /scripts/timed-events/events/*(name,time,recurring)/*(0,1,2,3,4,5,6)/*(zone,group,scene,blink,device,outputValue)

	var sString;
	var oServerObject;
	if ((id==null)||(id=='basisConfig')) {
		sString = ajaxSyncRequest(
				'/json/property/query',
				{
					'query' : '/scripts/presence-simulator/*(autoMode,emailMode,emailReceiver)'
				});
		oServerObject = eval('(' + sString + ')');
		setSimpleValue('basisConfig','autoMode',0);
		setSimpleValue('basisConfig','emailMode',0);
		if (oServerObject.result!=null)
			if (oServerObject.result['presence-simulator']!=null)
				for ( var iIndex = 0; iIndex < oServerObject.result['presence-simulator'].length; iIndex++) {
					var oObject=oServerObject.result['presence-simulator'][iIndex];
					if (oObject.autoMode!=null)
						setSimpleValue('basisConfig','autoMode',''+oObject.autoMode);
					if (oObject.emailMode!=null)
						setSimpleValue('basisConfig','emailMode',''+oObject.emailMode);
					if (oObject.emailReceiver!=null)
						setSimpleValue('basisConfig','emailReceiver',''+oObject.emailReceiver);
				}
	}
	
	if ((id==null)||(id=='holidays')) {
		sString = ajaxSyncRequest(
				'/json/property/query',
				{
					'query' : '/scripts/presence-simulator/values/holiday/*(name,id,von,bis)'
				});
		oServerObject = eval('(' + sString + ')');
		var oArrayHoliday = [];
		
		if (oServerObject.result!=null)
			if (oServerObject.result.holiday!=null)
				for ( var iIndex = 0; iIndex < oServerObject.result.holiday.length; iIndex++) {
					var oSubObject = oServerObject.result.holiday[iIndex];
					var oObject = {};
					if (oSubObject.id != null)
						oObject.id = oSubObject.id;
					if (oSubObject.name != null)
						oObject.name = oSubObject.name;
					if (oSubObject.bis != null)
						oObject.bis = parseInt(oSubObject.bis,10);
					if (oSubObject.von != null)
						oObject.von = parseInt(oSubObject.von,10);
					oArrayHoliday.push(oObject);
				}
	
		fillAppDataStore(oArrayHoliday,'holidays');	
	}
	
	if ((id==null)||(id=='actions')) {
		sString = ajaxSyncRequest(
				'/json/property/query',
				{
					'query' : '/scripts/timed-events/events/*(name,time,recurring)/*(0,1,2,3,4,5,6)/*(zone,group,scene,blink,device,outputValue)'
				});
		oServerObject = eval('(' + sString + ')');
		var oArrayTimedEvent = [];
		if (oServerObject.result!=null)
			if (oServerObject.result.events!=null)
				for ( var iIndex = 0; iIndex < oServerObject.result.events.length; iIndex++) {
					var oSubObject = oServerObject.result.events[iIndex];
					if (oSubObject.recurring) {
						var oObject = {};
						for (var oKey in oSubObject) {
							if (oKey=='name')
								oObject.name=oSubObject.name;
							else
							if (oKey=='recurring')
								{;}
							else
							if (oKey=='time') {
								oObject.time={};
								var oDate=new Date();
								if (oSubObject.time.indexOf('sunrise')!=-1){
									oObject.time.sunrise=0;
									var delta=parseInt(oSubObject.time.substring(8).split(':')[0],10)*3600;
									delta+=parseInt(oSubObject.time.substring(8).split(':')[1],10)*60;
									delta+=parseInt(oSubObject.time.substring(8).split(':')[2],10);
									if (oSubObject.time.substring(7,8)=='-') {
										oObject.time.sunrise=-delta;
									} else
										oObject.time.sunrise=delta;						
								} else
								if (oSubObject.time.indexOf('sunset')!=-1) {
									oObject.time.sunset=0;
									var delta=parseInt(oSubObject.time.substring(7).split(':')[0],10)*3600;
									delta+=parseInt(oSubObject.time.substring(7).split(':')[1],10)*60;
									delta+=parseInt(oSubObject.time.substring(7).split(':')[2],10);
									if (oSubObject.time.substring(6,7)=='-') {
										oObject.time.sunset=-delta;
									} else
										oObject.time.sunset=delta;						
								} else
								{	
									oDate.setHours(parseInt(oSubObject.time.split(':')[0],10));
									oDate.setMinutes(parseInt(oSubObject.time.split(':')[1],10));
									oDate.setSeconds(parseInt(oSubObject.time.split(':')[2],10), 0);
									oObject.time.start=Math.floor(oDate.getTime()/1000);
								}
								
							}
							else
							{
								oObject.reference=oKey;
								var oSubArray=oSubObject[oKey];
								for (var jIndex=0;jIndex<oSubArray.length;jIndex++)
								{
									var oSubObjectArray=oSubArray[jIndex];
									if (oSubObjectArray.recurrence!=null)
									{
										oObject.recurrence=[];
										for (var oRecKey in oSubObjectArray)
										{
											if (oRecKey!='recurrence')
												oObject.recurrence.push(oSubObjectArray[oRecKey]);
										}
									}
									if (oSubObjectArray.actions!=null)
									{
										oObject.action=[];
										for (var kIndex=0;kIndex<oSubObjectArray.actions.length;kIndex++)
										{
											var oActionobject=oSubObjectArray.actions[kIndex];
											var oSubObjectAction={};
											for (var actionKey in oActionobject)
												oSubObjectAction[actionKey]=oActionobject[actionKey];
											oObject.action.push(oSubObjectAction);
										}
									}
								}
								
							}
						}
						oObject.id=iIndex*-1;
						oObject.disabled=true;
						oObject.passive=true;
						
						oArrayTimedEvent.push(oObject);
					}
				}
		
		
		sString = ajaxSyncRequest(
				'/json/property/query',
				{
					'query' : '/scripts/presence-simulator/values/timed-event/*(id,timed-event-ref,disabled)'
				});
		oServerObject = eval('(' + sString + ')');
		if (oServerObject.result!=null)
			if (oServerObject.result['timed-event']!=null)
				for ( var iIndex = 0; iIndex < oServerObject.result['timed-event'].length; iIndex++) {
					var oSubObject = oServerObject.result['timed-event'][iIndex];
					for (var jIndex=0;jIndex<oArrayTimedEvent.length;jIndex++){
						var oArrayObject=oArrayTimedEvent[jIndex];
						if (oArrayObject.reference==oSubObject['timed-event-ref'])
							oArrayObject.disabled=oSubObject.disabled;
					}
				}
		
		sString = ajaxSyncRequest(
				'/json/property/query',
				{
					'query' : '/scripts/presence-simulator/values/actions/*(name,id,time,maxdiv,disabled,sunrise,sunset)/*(0,1,2,3,4,5,6,7)/*(zone,group,scene,delay)'
				});
		oServerObject = eval('(' + sString + ')');	
		if (oServerObject.result!=null)
			if (oServerObject.result.actions!=null)
				for (var iIndex=0;iIndex < oServerObject.result.actions.length;iIndex++)
				{
					var oSubObject = oServerObject.result.actions[iIndex];
					var oObject = {};
					oObject.time={};
					for (var oKey in oSubObject) {
			
						if (oKey=='id')
							oObject.id=oSubObject.id;
						else if (oKey=='disabled') {
							if (oSubObject[oKey]==true)
								oObject.disabled=true;
						}
						else if (oKey=='name')
							oObject.name=oSubObject.name;
						else if (oKey=='maxdiv')
							oObject.time.maxdiv=oSubObject.maxdiv;
						else if (oKey=='time') 	
							oObject.time.start=parseInt(oSubObject.time,10);
						else if (oKey=='sunrise') 	
							oObject.time.sunrise=parseInt(oSubObject.sunrise,10);
						else if (oKey=='sunset') 	
							oObject.time.sunset=parseInt(oSubObject.sunset,10);
						else
						{
							oObject.reference=oKey;
							var oSubArray=oSubObject[oKey];
							for (var jIndex=0;jIndex<oSubArray.length;jIndex++)
							{
								var oSubObjectArray=oSubArray[jIndex];
								if (oSubObjectArray.recurrence!=null)
								{
									oObject.recurrence=[];
									for (var oRecKey in oSubObjectArray)
									{
										if (oRecKey!='recurrence')
											oObject.recurrence.push(oSubObjectArray[oRecKey]);
									}
								}
								if (oSubObjectArray.actions!=null)
								{
									oObject.action=[];
									for (var kIndex=0;kIndex<oSubObjectArray.actions.length;kIndex++)
									{
										var oActionobject=oSubObjectArray.actions[kIndex];
										var oSubObjectAction={};
										for (var actionKey in oActionobject)
											oSubObjectAction[actionKey]=oActionobject[actionKey];
										oObject.action.push(oSubObjectAction);
									}
								}
							}
							
						}
					}
					oObject.passive=false;
					
					oArrayTimedEvent.push(oObject);
				}		
		fillAppDataStore(oArrayTimedEvent,'actions');	
	}
}

function saveValueFunction(oValue,id) {
	if (id=='holidays')
	{
		removePropertySync('/scripts/' + baseValues.appId + '/values/holiday/' + oValue.id);
		var oPropsArray = [
			{
				path : '/scripts/' + baseValues.appId + '/values/holiday/' + oValue.id
						+ '/id',
				value : oValue.id,
				message : 'Speichere Urlaub Daten'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/holiday/' + oValue.id
						+ '/name',
				value : oValue.name,
				message : 'Urlaub: "Namen" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/holiday/' + oValue.id
						+ '/von',
				value : ''+oValue.von,
				message : 'Urlaub: "von" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/holiday/' + oValue.id
						+ '/bis',
				value : ''+oValue.bis,
				message : 'Urlaub: "Bis" speichern'
			}
		];
		var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };
    	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);
	}
	if (id=='actions')
	{
		if (oValue.passive==true)
		{
			// timed Event
			var oPropsArray = [
 	   			{
   	   				path : '/scripts/' + baseValues.appId + '/values/timed-event/' + oValue.id
   	   						+ '/id',
   	   				value : oValue.id,
   	   				message : 'Speichere Verweis aus Timed-Event 1/3'
   	   			},
  	   			{
   	   				path : '/scripts/' + baseValues.appId + '/values/timed-event/' + oValue.id
   	   						+ '/timed-event-ref',
   	   				value : oValue.reference,
   	   				message : 'Speichere Verweis aus Timed-Event 2/3'
   	   			},
   	   			{
   	   				path : '/scripts/' + baseValues.appId + '/values/timed-event/' + oValue.id
   	   						+ '/disabled',
   	   				value : oValue.disabled,
   	   				message : 'Speichere Verweis aus Timed-Event 3/3'
   	   			}
   	   		];
			var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };
	       	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);
		} else {
			removePropertySync('/scripts/' + baseValues.appId + '/values/actions/' + oValue.id);
			var oPropsArray = [
	   			{
	   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
	   						+ '/id',
	   				value : oValue.id,
	   				message : 'Speichere Aktivit&auml;ten Daten'
	   			},
	   			{
	   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
	   						+ '/name',
	   				value : oValue.name,
	   				message : 'Aktivit&auml;ten: "Namen" speichern'
	   			},
	   			{
	   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
	   						+ '/maxdiv',
	   				value : oValue.time.maxdiv,
	   				message : 'Aktivit&auml;ten: "Varianz" speichern'
	   			},
	   			{
	   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
	   						+ '/disabled',
	   				value : oValue.disabled,
	   				message : 'Aktivit&auml;ten: "Aktiv" speichern'
	   			}
	   		];

			if (oValue.time.start!=null)
				oPropsArray.push({
	   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
	   						+ '/time',
	   				value : ''+oValue.time.start,
	   				message : 'Aktivit&auml;ten: "Zeit" speichern'
	   			});
			if (oValue.time.sunrise!=null)
				oPropsArray.push({
	   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
	   						+ '/sunrise',
	   				value : ''+oValue.time.sunrise,
	   				message : 'Aktivit&auml;ten: "Zeit" speichern'
	   			});
			if (oValue.time.sunset!=null)
				oPropsArray.push({
	   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
	   						+ '/sunset',
	   				value : ''+oValue.time.sunset,
	   				message : 'Aktivit&auml;ten: "Zeit" speichern'
	   			});

			
			var iIndex=0;
			for (iIndex=0;iIndex<oValue.recurrence.length;iIndex++)
				oPropsArray.push(
					{
		   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
		   						+ '/recurrence/' + iIndex,
		   				value : oValue.recurrence[iIndex],
		   				message : 'Aktivit&auml;ten: "Wiederholung '+(iIndex+1)+'/'+oValue.recurrence.length+'" speichern'
		   			}	
				);
	
			for (iIndex=0;iIndex<oValue.action.length;iIndex++)
			{
				oPropsArray.push(
						{
			   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
			   						+ '/actions/' + iIndex + '/zone',
			   				value : oValue.action[iIndex].zone,
			   				message : 'Aktivit&auml;ten: "Aktion '+(iIndex+1)+'/'+oValue.action.length+' : Raum" speichern'
			   			}	
					);
				oPropsArray.push(
						{
			   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
			   						+ '/actions/' + iIndex + '/group',
			   				value : oValue.action[iIndex].group,
			   				message : 'Aktivit&auml;ten: "Aktion '+(iIndex+1)+'/'+oValue.action.length+' : Gruppe" speichern'
			   			}	
					);
				oPropsArray.push(
						{
			   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
			   						+ '/actions/' + iIndex + '/scene',
			   				value : oValue.action[iIndex].scene,
			   				message : 'Aktivit&auml;ten: "Aktion '+(iIndex+1)+'/'+oValue.action.length+' : Aktivit&auml;t" speichern'
			   			}	
					);
				oPropsArray.push(
						{
			   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
			   						+ '/actions/' + iIndex + '/delay',
			   				value : oValue.action[iIndex].delay,
			   				message : 'Aktivit&auml;ten: "Aktion '+(iIndex+1)+'/'+oValue.action.length+' : Verz&ouml;gerung" speichern'
			   			}	
					);
			}
							
	   		var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };
	       	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);
		}
	}
}

function deleteValueFunction(oValue,id) {
	if (id=='holidays')
		removePropertySync('/scripts/' + baseValues.appId + '/values/holiday/' + oValue.id);
	else
	if (id=='actions')
		if (oValue.passive==false)
			removePropertySync('/scripts/' + baseValues.appId + '/values/actions/' + oValue.id);
	
	loadValueFunction();
}

function modeChange(newValue)
{
	var oPropsArray = [
	       			{
	       				path : '/scripts/' + baseValues.appId + '/general/autoMode',
	       				value : newValue,
	       				message : 'Speichere Automatikmodus'
	       			} ];
	var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };
   	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);	
}

function messageChange(newValue)
{
	var oPropsArray = [
		       			{
		       				path : '/scripts/' + baseValues.appId + '/general/emailMode',
		       				value : newValue,
		       				message : 'Speichere Emailmodus'
		       			} ];
		var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };
	   	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);	
}
function emailChange(newValue)
{
	var oPropsArray = [
		       			{
		       				path : '/scripts/' + baseValues.appId + '/general/emailReceiver',
		       				value : newValue,
		       				message : 'Speichere Email'
		       			} ];
		var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };
	   	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);	
}

function statusRenderer()
{
	if (getPropertyBoolean('/scripts/' + baseValues.appId + '/general/active'))
		return "Status der Simulation: <b>AKTIV</b>";
	else
		return "Status der Simulation: <b>nicht aktiv</b>";
}

Ext.onReady(function() {
	initValues();
	var tabDev=
	[
	 {
		type:'simple',
		id: 'basisConfig',
		name:'Allgemein',
		items:[
		        {type:'auto_query',
			    	id:'appState',
			    	changeListener:statusRenderer
   			    }, 
    			{type:'choose',
			    	title:'Wann soll die Automatik aktiv sein?',
			    	id:'autoMode',
			    	changeListener:modeChange,
			    	options:[{text:'Abgeschaltet: Die Anwesenheitssimulation ist abgeschaltet. Keine Auswertung der Urlaubszeiten oder der Aktiv&auml;ten werden durchgef&uuml;hrt', value:0},
			    	         {text:'Nur zu bestimmten Urlaubszeiten',value:1},
			    	         {text:'Zu Urlaubszeiten, und immer w&auml;hrend der Aktivit&auml;t "Gehen"',value:2},
			    	         {text:'Eingeschaltet: Die Anwesenheitssimulation ist eingeschaltet und wird nicht durch Urlaubszeiten oder Aktivit&auml;ten abgeschaltet', value:3}]},
  		       {type:'choose',
    			    	title:'Soll eine Email bei jedem Ein- und Ausschalten versendet werden?',
    			    	id:'emailMode',
    			    	changeListener:messageChange,
    			    	options:[{text:'Nein', value:0},
    			    	         {text:'Ja',value:1} ]
    			}, 
   		        {type:'text_email',
			    	title:'Empf&auml;nger',
			    	id:'emailReceiver',
			    	changeListener:emailChange
   			    }, 
    			{type:'static',
    				html:'<b>Tipp: Beachten Sie folgendes w&auml;hrend Ihrer Abwesenheit</b><br>'+
    				     'Eine Anwesenheitssimulaiton kann nur gelingen, wenn auch auf die folgenden Dinge geachtet wird:<br>'+
    					 '<ul style="padding: 20px;"><li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">Der Briefkasten darf wegen ungeleerter Post nicht &uuml;berquellen.</li>'+
    				     '<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">Das Telefon muss weitergeleitet werden.</li>'+
    				     '<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">Bl&auml;tter und Laub d&uuml;rfen nicht l&auml;ngere Zeit auf dem Zugangsweg oder der Einfahrt liegen bleiben.</li>'+
    				     '<li style="list-style: disc inside none;color:#005138;padding-bottom: 4px;">Die Gegensprechanlage sollte beantwortet werden.</li></ul>'
    				     }
		       ]},
	 {  type:'grid',
		id: 'holidays',
		name:'Urlaubszeiten',
		noactivColumn:true,
		columns:[ {
			type : 'string',
			name : "name",
			title : "Name"
		}, {
			type : 'datetime',   //unix-ts
			name : "von",
			title : "Von"
			
		}, {
			type : 'datetime',   //unix-ts
			name : "bis",
			title : "Bis"
		}] 
	 },
	 {type:'grid',
		id:'actions',
		name:'Aktivit&auml;ten',
		columns:[{
			type : 'custom',
			name : "passive",
			title : "",
			width: 36,
			renderfkt: 
				function(val, metadata, record, colIdx, store, view) {
					if (view.storeId!='appDataStore') {
						tapId=view.storeId.substring(13);
						if (multiPassiveColumn[tapId]!=null)
							if (record.get(multiPassiveColumn[tapId])!=null)
								if (record.get(multiPassiveColumn[tapId])==true)
									return '<img src="timed_event.png">';					
					}
					return "";
				},
			editorOrder : 0.1
		},{
			type : 'string',
			name : "name",
			title : "Name",
			editorOrder : 1.0
		},{
			type : 'action',           // array [{ ZoneID,GroupID,dSID,SceneID/value/blink delay}]
			name : "action",
			title : "Handlung",
			editorOrder : 3.0
		},{
			type : 'time_with_random',   //unix-ts
			name : "time",
			width: 160,			
			title : "Zeit",
			editorOrder : 2.0,
			defaultValue : 39600
		},{
			type : 'recurrence_weekly',  // array [MO,TU] ....
			name : "recurrence",
			width:200,
			title : "H&auml;ufigkeit",
			editorOrder : 2.5
		},{
			type : 'hidden',
			name : 'reference'
		},{
			type : 'hidden',
			name : 'passive'
		}],
		passiveColumn:'passive'		
	 }];
	
	
	initAppDataStore([ 'id','name', 'von', 'bis' ],'holidays');
	initAppDataStore([ 'id','name', 'action', 'time', 'recurrence','passive' ],'actions');
	
	makeMultiPanel(tabDev, saveValueFunction, deleteValueFunction,checkMinimalVersion,saveSingularValue);
	loadValueFunction('basisConfig');
	loadValueFunction('holidays');
	loadValueFunction('actions');
});


function saveSingularValue(oValue,propertyName,id)
{
	if (id=="actions")
		if (propertyName=="disabled") {
			if (oValue.passive==true)
			{
				// timed Event
				var oPropsArray = [
	 	   			{
	   	   				path : '/scripts/' + baseValues.appId + '/values/timed-event/' + oValue.id
	   	   						+ '/id',
	   	   				value : oValue.id,
	   	   				message : 'Speichere Verweis aus Timed-Event 1/3'
	   	   			},
	  	   			{
	   	   				path : '/scripts/' + baseValues.appId + '/values/timed-event/' + oValue.id
	   	   						+ '/timed-event-ref',
	   	   				value : oValue.reference,
	   	   				message : 'Speichere Verweis aus Timed-Event 2/3'
	   	   			},
	   	   			{
	   	   				path : '/scripts/' + baseValues.appId + '/values/timed-event/' + oValue.id
	   	   						+ '/disabled',
	   	   				value : oValue.disabled,
	   	   				message : 'Speichere Verweis aus Timed-Event 3/3'
	   	   			}
	   	   		];
				var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };
		       	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);
			} else {
				var oPropsArray = [
		   			{
		   				path : '/scripts/' + baseValues.appId + '/values/actions/' + oValue.id
		   						+ '/disabled',
		   				value : oValue.disabled,
		   				message : 'Aktivit&auml;ten: "Aktiv" speichern'
		   			}
		   		];
								
		   		var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };
		       	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);
			}
			return;
		}  

	saveValueFunction(oValue,id);
}